#define num_datasets 720

String colors[num_sensors_max] = {"red","green","magenta","orange","lime","yellow"};

struct wp
{
  uint8_t temp[num_sensors_max];
  int8_t hour;
};

wp wp_arr[num_datasets];
uint16_t datasetpt = 0;

void clearwp()
{
  for(int i=0;i<num_datasets;i++) wp_arr[i].hour = -1;
}

void storewp(int inp[], int8_t hour)
{
  wp_arr[datasetpt].hour = hour;
  for (int i=0;i<num_sensors;i++) 
    wp_arr[datasetpt].temp[i] = (uint8_t)constrain(inp[i],0,254);
  datasetpt++;
  if (datasetpt >= num_datasets) datasetpt = 0;
}

void handleNotFound() 
{
  server.send(404, "text/plain", "Not Here");
}

int8_t oldstate = 0;

void drawGraph() 
{
  String out;
  out.reserve(3000);
  uint8_t oldwp = 0; int oldi = 0;
  int8_t oldhour = -1;

// 210 - temp*3

  out += "<svg viewBox=\"0 0 740 240\" xmlns=\"http://www.w3.org/2000/svg\">\n";
  out += "<rect x=\"10\" y=\"0\" width=\"720\" height=\"240\" stroke=\"black\" fill=\"none\"/>\n";
  out += "<line x1=\"10\" y1=\"120\" x2=\"730\" y2=\"120\" stroke=\"silver\"/>\n";
  out += "<line x1=\"10\" y1=\"160\" x2=\"730\" y2=\"160\" stroke=\"silver\"/>\n";
  out += "<line x1=\"10\" y1=\"200\" x2=\"730\" y2=\"200\" stroke=\"silver\"/>\n";
//out += "<text x=\"15\" y=\"10\" stroke=\"grey\" font-size=\"50%\">0..80deg, 12 h</text>\n";
  
#if defined has_ntp
  for (int i=0;i<num_datasets;i++)
  {
    int8_t newstate, newhour;
    uint16_t pos = datasetpt + i;
    if (pos >= num_datasets) pos -= num_datasets;
    newhour = wp_arr[pos].hour;
    if ((newhour != oldhour) && (oldhour >= 0))
    {
      char temp[100];
      if ((newhour == 12) || (newhour == 0))  // 12, 24
      {
        sprintf(temp,"<line x1=\"%d\" y1=\"115\" x2=\"%d\" y2=\"85\" stroke=\"black\" />\n",10+i,10+i);
        out += temp;        
      }
      else if ((newhour == 6) || (newhour == 18)) // 6, 18
      {
        sprintf(temp,"<line x1=\"%d\" y1=\"108\" x2=\"%d\" y2=\"92\" stroke=\"black\" />\n",10+i,10+i);
        out += temp;        
      }
      else 
      {
        sprintf(temp,"<line x1=\"%d\" y1=\"104\" x2=\"%d\" y2=\"96\" stroke=\"black\" />\n",10+i,10+i);
        out += temp;        
      }
    }
    oldhour = newhour;
  }
#endif
    
  for (int k=0;k<num_sensors;k++)
  {
    out += "<polyline points=\"";
    char temp[100];
    // datasetpt is now, show the past
    for (int i=0;i<num_datasets;i++)
    {
      uint16_t pos = datasetpt + i;
      if (pos >= num_datasets) pos -= num_datasets;
      if (wp_arr[pos].hour >= 0)
      {
        int tempdata = wp_arr[pos].temp[k];
        sprintf(temp,"%d,%d ",10+i,240-tempdata);
        out += temp;
      }
    }
    out += "\" fill=\"none\" stroke=\""; out += colors[k]; out += "\" />\n"; 
  }
  
  out += "</svg>\n";
  
  server.send(200, "image/svg+xml", out);
}
